// PDFViewerActiveTestMDIView.cpp : implementation of the CPDFViewerActiveTestMDIView class
//
/////////////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "resource.h"

#include "PDFViewerActiveTestMDIView.h"

BOOL CPDFViewerActiveTestMDIView::PreTranslateMessage(MSG* pMsg)
{
	if((pMsg->message < WM_KEYFIRST || pMsg->message > WM_KEYLAST) &&
	   (pMsg->message < WM_MOUSEFIRST || pMsg->message > WM_MOUSELAST))
		return FALSE;

	HWND hWndCtl = ::GetFocus();
	if(IsChild(hWndCtl))
	{
		// find a direct child of the dialog from the window that has focus
		while(::GetParent(hWndCtl) != m_hWnd)
			hWndCtl = ::GetParent(hWndCtl);

		// give control a chance to translate this message
		if(::SendMessage(hWndCtl, WM_FORWARDMSG, 0, (LPARAM)pMsg) != 0)
			return TRUE;
	}

	return CWindow::IsDialogMessage(pMsg);
}

LRESULT CPDFViewerActiveTestMDIView::OnSize(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	CRect rc;
	GetClientRect(rc);
	rc.DeflateRect(5,5);

	static LONG bw = 0;
	static LONG bh = 0;
	if (bw == 0)
	{
		CRect rb;
		::GetWindowRect(GetDlgItem(IDC_OPEN), &rb);
		bw = rb.Width();
		bh = rb.Height();
	}

	CRect r;
	r.right = rc.Width(); 
	r.left = r.right - bw;
	r.top = rc.bottom - bh;
	r.bottom = rc.bottom;

	::SetWindowPos(GetDlgItem(IDC_OPEN), NULL, r.left, r.top, r.Width(), r.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
	
	HWND hWnd = GetDlgItem(IDC_COPDFXCVIEW1);
	if (hWnd != NULL)
	{
		rc.bottom = r.top - 5;
		::SetWindowPos(hWnd, NULL, rc.left, rc.top, rc.Width(), rc.Height(), SWP_NOZORDER | SWP_NOACTIVATE);
	}

	bHandled = FALSE;
	return 0;
}
LRESULT CPDFViewerActiveTestMDIView::OnBnClickedOpen(WORD /*wNotifyCode*/, WORD /*wID*/, HWND /*hWndCtl*/, BOOL& /*bHandled*/)
{
	LONG nID = 0;
	m_spView->OpenDocument(NULL, NULL, &nID, 0);

	return 0;
}

LRESULT CPDFViewerActiveTestMDIView::OnInit(UINT uMsg, WPARAM wParam, LPARAM lParam, BOOL& bHandled)
{
	GetDlgControl(IDC_COPDFXCVIEW1, IID_IPDFXCview, (void**)&m_spView);

	CComVariant val;
	val = L"MDI";
	m_spView->SetProperty(__S2BS(L"General.DocumentInterface"), val, 0);

	val = L"true";
	m_spView->SetProperty(__S2BS(L"View.Bars[\"Menu\"].Visible"), val, 0);

	return 0;
}

void CPDFViewerActiveTestMDIView::OnActivate(BOOL bActivate)
{
	CComPtr<IOleInPlaceActiveObject> sp;
	sp = m_spView;
	sp->OnFrameWindowActivate(bActivate);
}
